<template>
  <div class="view custers-create">
    <el-form inline label-position="left" label-width="140px" v-loading="loading">
      <section class="section">
        <p class="label">Cluster name</p>
        <el-input class="cluster-name" v-model="cluster.name" placeholder="cluster_name" @blur="updateCluster" @keyup.enter="updateCluster" disabled></el-input>
      </section>
      <section class="section" v-if="job && job.status === 'succeeded'">
        <el-row :gutter="20" class="label">
          <el-col :span="4">Application</el-col>
          <el-col :span="4">Login</el-col>
          <el-col :span="4">Password</el-col>
        </el-row>
        <el-row :gutter="20" v-for="clID in clusterDescription" :key="clID.ID" class="description">
          <el-col :span="4">
            <a target="_blank" rel="noreferrer noopener" v-bind:href="clID.endpoint" >{{ clID.name }}</a>
          </el-col>
          <el-col :span="4">
            {{ clID.login }}
            <el-button v-clipboard="clID.login" title="Copy to clipboard" class="copy-button">📋</el-button>
          </el-col>
          <el-col :span="4">
            {{ clID.password }}
            <el-button v-clipboard="clID.password" title="Copy to clipboard" class="copy-button">📋</el-button>
          </el-col>
        </el-row>
      </section>


      <section class="section" v-if="jobs.length">
        <p class="label">Deployments</p>

        <el-row :gutter="20" v-for="job in jobs" :key="job.id" class="deployment">
          <el-col :span="4">
            <a href="#" @click.prevent="selectDeploy(job.id)">{{ job.started | moment('MM/DD/YYYY HH:mm:ss') }}</a>
          </el-col>
          <el-col :span="4">{{ job.playbook }}</el-col>
          <el-col :span="4">{{ job.status }}</el-col>
        </el-row>

        <el-row v-if="console.length || job">
          <el-col :span="16">
            <div class="console" v-loading="logsFetching" id="logConsole">
              <div class="line" :class="line.type" v-for="(line, k) in console" :key="k">
                <span class="ts">{{ line.ts | moment('MM/DD/YYYY HH:mm:ss') }}</span>
                <span class="text">{{ line.text }}</span>
              </div>
            </div>
            <p class="status">Status: {{ job.status }}</p>
          </el-col>
        </el-row>
      </section>

      <section class="section">
        <el-button type="primary" class="button" size="medium" @click="deployCluster" v-if="(!job || job.status != 'started')">
          Deploy cluster
        </el-button>
        <el-button type="primary" class="button" size="medium" @click="destroyCluster(false)" v-if="(!job || job.status != 'started')">
          Purge cluster
        </el-button>
        <el-button type="primary" class="button" size="medium" @click="destroyDeploy" v-if="job && job.status === 'started'">
          Cancel
        </el-button>
      </section>

      <section class="section">
        <p class="label">Download SSH private key</p>
        <small>Add this unique autogenerated SSH key to your ~/.ssh/config config be able to connect via SSH to created nodes.</small>
        <p></p>
        <el-button type="primary" class="button" size="medium" @click="downloadSSHKey" :loading="downloadingSSH">{{ downloadButtonText }}</el-button>
      </section>
      <section class="section">
        <p class="label">Danger zone</p>

        <div class="danger-zone">
          <el-button type="primary" class="button" size="medium" plain @click="destroyCluster(true)">Remove cluster</el-button>
        </div>
      </section>
    </el-form>
  </div>
</template>

<script>
function download(data, name) {
  let element = document.createElement('a')
  element.setAttribute('href', `data:text/plain;charset=utf-8,${encodeURIComponent(data)}`)
  element.setAttribute('download', name)
  element.style.display = 'none'
  document.body.appendChild(element)
  element.click()
  document.body.removeChild(element)
}

export default {
  data () {
    return {
      applications: [
        { id: 0, label: 'AEM Environment' },
        { id: 1, label: 'Hybris B2C' },
        { id: 2, label: 'SAP Hybris Delivery Platform' },
        { id: 3, label: 'Oracle Commerce Delivery Platform' },
        { id: 4, label: 'Hybris CI/CD'},
        { id: 5, label: 'HTTP Artifac storage'},
        { id: 6, label: 'Hybris CI Environment' },
        { id: 7, label: 'Hybris FV Environment' },
        { id: 8, label: 'Ansible Development Kit' },
        { id: 9, label: 'Shaper' },
        { id: 10, label: 'AEM CI/CD' },
        { id: 11, label: 'Pardomain' }
      ],

      playbook: 'kubespray',
      
      entrypoints: {
        create: 'run.sh',
        destroy: 'destroy.sh'
      },

      cluster: {
        id: null,
        name: null
      },

      jobs: [],
      job: null,
      jobStatus: 'deploying...',

      nodes: [],
      node: '',

      application: 1,
      helm: true,

      console: [],

      loading: false,
      loadingNodes: false,
      downloadingSSH: false,
      downloadingArtifact: false,
      logsFetching: false,
      logsInterval: null,

      sshKey: '',
      clusterDescription: '',
      downloadButtonText: 'Download SSH private key',
      copyButtonText: 'Copy SSH private key',
    }
  },

  created () {
    this.$store.dispatch('breadcrumbs', [
      { label: 'Clusters', route: { name: 'clusters' } },
      { label: '', route: { name: 'clusters.view', params: { id: this.$route.params.id } } }
    ])

    this.fetch()
    // this.fetchNodes()
    this.fetchDeploys().finally(() => {
      if (this.jobs.length) {
        let lastJob = this.jobs[this.jobs.length - 1]
        if (lastJob.status === 'started') {
          this.autoFetchDeployments(lastJob.id)
        }
        if (lastJob.status === 'succeeded') {
          this.autoFetchDeployments(lastJob.id)
        }
      }
    })
  },

  updated() {
    let container = document.getElementById('logConsole')
    if (container) {
      container.scrollTop = container.scrollHeight
    }
  },

  methods: {

    fetchClusterDescription () {
      return this.$api.getClusterDescriptionByID(this.$route.params.id).then(response => {
        this.clusterDescription = response.data
      })
    },

    fetch () {
      this.loading = true
      this.$api.getClusterByID(this.$route.params.id).then(response => {
        this.cluster = response.data

        this.$store.dispatch('breadcrumbs', [
          { label: 'Clusters', route: { name: 'clusters' } },
          { label: this.cluster.name, route: { name: 'clusters.view', params: { id: this.$route.params.id } } }
        ])
      }).finally(() => {
        this.loading = false
      })
    },

    fetchNodes () {
      this.loadingNodes = true
      this.$api.getClusterNodes(this.$route.params.id).then(response => {
        this.nodes = response.data
      }).finally(() => {
        this.loadingNodes = false
      })
    },

    fetchDeploy (id) {
      return this.$api.getClusterDeploy(this.$route.params.id, id).then(response => {
        this.job = response.data
      })
    },

    fetchDeploys () {
      return this.$api.getClusterDeploys(this.$route.params.id).then(response => {
        this.jobs = response.data
      })
    },

    fetchLogs (id) {
      this.$api.getClusterDeployLogs(this.$route.params.id, id).then(response => {
        this.console = response.data
      })
    },

    updateCluster () {
      this.$api.updateCluster(this.$route.params.id, this.cluster).then(() => {
        this.$message('Cluster name was saved')
      })
    },

    autoFetchDeployments (id) {
      clearInterval(this.logsInterval)

      this.fetchLogs(id)
      this.fetchDeploy(id).then(() => {
        if (this.job.status === 'succeeded' || this.job.status === 'failed') {
          clearInterval(this.logsInterval)
        }
      })
      this.fetchDeploys()
      this.fetchClusterDescription()

      this.logsInterval = setInterval(() => {
        this.fetchLogs(id)
        this.fetchDeploy(id).then(() => {
          if (this.job.status === 'succeeded' || this.job.status === 'failed') {
            clearInterval(this.logsInterval)
          }
        })
        this.fetchDeploys()
        this.fetchClusterDescription()
      }, 10000)
    },

    selectDeploy (id) {
      this.fetchDeploy(id).then(() => {
        this.fetchLogs(id)
      })
    },

    downloadSSHKey () {
      this.downloadingSSH = true
      this.$api.getClusterSSHKeyByID(this.$route.params.id).then(response => {
        download(atob(response.data.key), `id_rsa_${this.cluster.name}.pem`)
      }).catch(error => {
        if (error.response.status === 404) {
          return this.$api.generateNewSSHKeyByID(this.$route.params.id).then(() => {
            this.downloadSSHKey()
          })
        } else {
          this.$notify.error({
            title: `Error ${error.response.data.code}`,
            message: error.response.data.message
          })
        }
      }).finally(() => {
        this.downloadingSSH = false
      })
    },

    deployCluster () {
      this.$api.createClusterDeploy(this.$route.params.id, {
        warm_smiley: "^_^"
      }).then(response => {
        this.job = response.data
        this.autoFetchDeployments(response.data.id)
      }).catch(error => {
        this.$notify.error({
          title: `Error code ${error.response.data.code}`,
          message: error.response.data.message
        })
      })
    },

    destroyCluster (doRemoveDbEntryFlag) {
      this.$confirm('Cluster will be destroyed!', 'Warning').then(() => {
        if (doRemoveDbEntryFlag == null){
          doRemoveDbEntryFlag = true
        }
        return this.$api.destroyClusterByID(this.$route.params.id, {
          doRemoveDbEntry: doRemoveDbEntryFlag
        }).then(() => {
          if (doRemoveDbEntryFlag == true){
            this.$router.push({ name: 'clusters' })
          } else {
            this.fetchDeploys().finally(() => {
              if (this.jobs.length) {
                let lastJob = this.jobs[this.jobs.length - 1]
                if (lastJob.status === 'started') {
                  this.autoFetchDeployments(lastJob.id)
                }
                if (lastJob.status === 'succeeded') {
                  this.autoFetchDeployments(lastJob.id)
                }
              }
            })
          }
        }).catch(error => {
          this.$notify.error({
            title: `Error code ${error.response.data.code}`,
            message: error.response.data.message
          })
        })
      }).finally(() => {
        this.loading = false
      })
    },

    destroyDeploy () {
      this.$api.destroyClusterDeploy(this.$route.params.id, this.job.id).then(() => {
        this.job = null
        clearInterval(this.logsInterval)
        this.fetchDeploys()
      })
    },

    downloadArtifact (name) {
      this.downloadingArtifact = true
      this.$api.downloadClusterDeployArtifact(this.$route.params.id, this.job.id, name).then(response => {
        download(response.data, name)
      }).catch(error => {
        this.$notify.error({
          title: `Error ${error.response.data.code}`,
          message: error.response.data.message
        })
      }).finally(() => {
        this.downloadingArtifact = false
      })
    }
  }
}
</script>

<style lang="scss">
.copy-text-input {
  opacity: 0;
  width: 1px;
  height: 1px;
}

.button-ssh {
  line-height: 20px;
  display: block;
  width: 100%;
  margin-bottom: 10px;
}

.select-button {
  text-transform: uppercase;
  //text-decoration: underline;
  text-align: center;
  cursor: pointer;
  //font-weight: 500;
  border: 1px solid #999999;
  border-bottom: 8px solid #999999;
  padding: 22px 30px;
  margin-bottom: 10px;
  min-height: 95px;
  box-sizing: border-box;

  &.checked {
    border-bottom: 8px solid #39C2D7;
  }
}

.cluster-name {
  &.el-input {
    max-width: 460px;
  }
}

.input-group {
  .icon, .input {
    display: inline-block !important;
    width: auto;
  }

  .cluster-name {
    display: inline-block !important;
    width: 300px;
  }

  .icon {
    width: 36px;
    height: 36px;
    text-align: center;
    cursor: pointer;
  }
}

.console {
  background: #000;
  width: 100%;
  min-height: 200px;
  max-height: 549px;
  overflow: auto;
  padding: 10px;
  margin-top: 20px;
  border-radius: 4px;

  .line {
    color: #fff;
    font-size: 12px;
    font-family: monospace;

    .ts {
      margin-right: 5px;
      white-space: nowrap;
    }
  }
}

.danger-zone {
  .button {
    width: 100%;
    margin: 0;
    display: block;
    margin-bottom: 18px;
    background: #fff;
  }
}

.status {
  font-size: 14px;
  margin-bottom: 5px;
  color: #606266;
}

.consoleuse {
  font-size: 14px;
  margin-bottom: 5px;
  color: #fff;
  font-family: monospace;
  background: #000;
  padding: 5px;
}

.deployment {
  font-size: 14px;
  margin-bottom: 5px;
  color: #606266;

  a {
    color: #606266;
  }
}
.description {
  font-size: 14px;
  margin-bottom: 5px;
  color: #606266;

  a {
    color: #606266;
  }
}
.copy-button{
  width:20px;
  height:20px;
  padding:0;
  margin:0;
    background-color: Transparent;
    background-repeat:no-repeat;
    border: none;
    cursor:pointer;
    overflow: hidden;
    outline:none;
}
</style>
